defmodule NullaWeb.Api.AnnounceJSON do
  alias Nulla.Announces.Announce

  @doc """
  Renders a list of announces.
  """
  def index(%{announces: announces}) do
    %{data: for(announce <- announces, do: data(announce))}
  end

  @doc """
  Renders a single announce.
  """
  def show(%{announce: announce}) do
    %{data: data(announce)}
  end

  defp data(%Announce{} = announce) do
    %{
      id: announce.id
    }
  end
end
